##
## EPITECH PROJECT, 2018
## lib
## File description:
## Makefile
##

CC = gcc
CCPP = g++
CASM = nasm
CFLAGS += -W -Wall -Wextra -c -masm=intel
CPPFLAGS += -W -Wall -Wextra -c
ASMFLAGS +=
IFLAGS += -I./$(INC_DIR)

OBJ_DIR	=	obj
SRC_DIR	=	src

INC_DIR	=	include
VPATH	=	$(SRC_DIR)

NAME	=	libmy.a
NAME2	=	libmy-dev.a

SRC	 =	src/dic/add.c
SRC	+=	src/dic/count.c
SRC	+=	src/dic/crc.c
SRC	+=	src/dic/del.c
SRC	+=	src/dic/find.c
SRC	+=	src/dic/get.c
SRC	+=	src/dic/index.c
SRC	+=	src/dic/iterator.c
SRC	+=	src/dic/new.c
SRC	+=	src/dic/serialize.c
SRC	+=	src/dic/set.c
SRC	+=	src/dic/unfragment.c
SRC	+=	src/dic/unserialize.c
SRC	+=	src/garbage_collector/calloc.c
SRC	+=	src/garbage_collector/close.c
SRC	+=	src/garbage_collector/free.c
SRC	+=	src/garbage_collector/freeAll.c
SRC	+=	src/garbage_collector/garbage_collector.c
SRC	+=	src/garbage_collector/itoa.c
SRC	+=	src/garbage_collector/join.c
SRC	+=	src/garbage_collector/malloc.c
SRC	+=	src/garbage_collector/memcpy.c
SRC	+=	src/garbage_collector/memmove.c
SRC	+=	src/garbage_collector/memset.c
SRC	+=	src/garbage_collector/open.c
SRC	+=	src/garbage_collector/realloc.c
SRC	+=	src/garbage_collector/rel_realloc.c
SRC	+=	src/garbage_collector/size.c
SRC	+=	src/garbage_collector/socket.c
SRC	+=	src/garbage_collector/strdup.c
SRC	+=	src/get_next_line.c
SRC	+=	src/log/log.c
SRC	+=	src/socket/accept.c
SRC	+=	src/socket/bind.c
SRC	+=	src/socket/close.c
SRC	+=	src/socket/connect.c
SRC	+=	src/socket/listen.c
SRC	+=	src/socket/recv.c
SRC	+=	src/socket/send.c
SRC	+=	src/socket/socket.c
SRC	+=	src/socket/update.c

OBJ	 =	obj/dic/add.o
OBJ	+=	obj/dic/count.o
OBJ	+=	obj/dic/crc.o
OBJ	+=	obj/dic/del.o
OBJ	+=	obj/dic/find.o
OBJ	+=	obj/dic/get.o
OBJ	+=	obj/dic/index.o
OBJ	+=	obj/dic/iterator.o
OBJ	+=	obj/dic/new.o
OBJ	+=	obj/dic/serialize.o
OBJ	+=	obj/dic/set.o
OBJ	+=	obj/dic/unfragment.o
OBJ	+=	obj/dic/unserialize.o
OBJ	+=	obj/garbage_collector/calloc.o
OBJ	+=	obj/garbage_collector/close.o
OBJ	+=	obj/garbage_collector/free.o
OBJ	+=	obj/garbage_collector/freeAll.o
OBJ	+=	obj/garbage_collector/garbage_collector.o
OBJ	+=	obj/garbage_collector/itoa.o
OBJ	+=	obj/garbage_collector/join.o
OBJ	+=	obj/garbage_collector/malloc.o
OBJ	+=	obj/garbage_collector/memcpy.o
OBJ	+=	obj/garbage_collector/memmove.o
OBJ	+=	obj/garbage_collector/memset.o
OBJ	+=	obj/garbage_collector/open.o
OBJ	+=	obj/garbage_collector/realloc.o
OBJ	+=	obj/garbage_collector/rel_realloc.o
OBJ	+=	obj/garbage_collector/size.o
OBJ	+=	obj/garbage_collector/socket.o
OBJ	+=	obj/garbage_collector/strdup.o
OBJ	+=	obj/get_next_line.o
OBJ	+=	obj/log/log.o
OBJ	+=	obj/socket/accept.o
OBJ	+=	obj/socket/bind.o
OBJ	+=	obj/socket/close.o
OBJ	+=	obj/socket/connect.o
OBJ	+=	obj/socket/listen.o
OBJ	+=	obj/socket/recv.o
OBJ	+=	obj/socket/send.o
OBJ	+=	obj/socket/socket.o
OBJ	+=	obj/socket/update.o

OBJ2	 =	obj-dev/dic/add-dev.o
OBJ2	+=	obj-dev/dic/count-dev.o
OBJ2	+=	obj-dev/dic/crc-dev.o
OBJ2	+=	obj-dev/dic/del-dev.o
OBJ2	+=	obj-dev/dic/find-dev.o
OBJ2	+=	obj-dev/dic/get-dev.o
OBJ2	+=	obj-dev/dic/index-dev.o
OBJ2	+=	obj-dev/dic/iterator-dev.o
OBJ2	+=	obj-dev/dic/new-dev.o
OBJ2	+=	obj-dev/dic/serialize-dev.o
OBJ2	+=	obj-dev/dic/set-dev.o
OBJ2	+=	obj-dev/dic/unfragment-dev.o
OBJ2	+=	obj-dev/dic/unserialize-dev.o
OBJ2	+=	obj-dev/garbage_collector/calloc-dev.o
OBJ2	+=	obj-dev/garbage_collector/close-dev.o
OBJ2	+=	obj-dev/garbage_collector/free-dev.o
OBJ2	+=	obj-dev/garbage_collector/freeAll-dev.o
OBJ2	+=	obj-dev/garbage_collector/garbage_collector-dev.o
OBJ2	+=	obj-dev/garbage_collector/itoa-dev.o
OBJ2	+=	obj-dev/garbage_collector/join-dev.o
OBJ2	+=	obj-dev/garbage_collector/malloc-dev.o
OBJ2	+=	obj-dev/garbage_collector/memcpy-dev.o
OBJ2	+=	obj-dev/garbage_collector/memmove-dev.o
OBJ2	+=	obj-dev/garbage_collector/memset-dev.o
OBJ2	+=	obj-dev/garbage_collector/open-dev.o
OBJ2	+=	obj-dev/garbage_collector/realloc-dev.o
OBJ2	+=	obj-dev/garbage_collector/rel_realloc-dev.o
OBJ2	+=	obj-dev/garbage_collector/size-dev.o
OBJ2	+=	obj-dev/garbage_collector/socket-dev.o
OBJ2	+=	obj-dev/garbage_collector/strdup-dev.o
OBJ2	+=	obj-dev/get_next_line-dev.o
OBJ2	+=	obj-dev/log/log-dev.o
OBJ2	+=	obj-dev/socket/accept-dev.o
OBJ2	+=	obj-dev/socket/bind-dev.o
OBJ2	+=	obj-dev/socket/close-dev.o
OBJ2	+=	obj-dev/socket/connect-dev.o
OBJ2	+=	obj-dev/socket/listen-dev.o
OBJ2	+=	obj-dev/socket/recv-dev.o
OBJ2	+=	obj-dev/socket/send-dev.o
OBJ2	+=	obj-dev/socket/socket-dev.o
OBJ2	+=	obj-dev/socket/update-dev.o

all: $(NAME) $(NAME2)

$(NAME): $(OBJ)
	ar cr $@ $^

$(NAME2): $(OBJ2)
	ar cr $@ $^

$(OBJ_DIR)-dev/%-dev.o: %.c
	@mkdir -p $(@D)
	@echo $(CC) $<
	@$(CC) $(CFLAGS) -o $@ $< $(IFLAGS) -DDEBUG -g

$(OBJ_DIR)-dev/%-dev.o: %.cpp
	@mkdir -p $(@D)
	@echo $(CCPP) $<
	@$(CCPP) $(CPPFLAGS) -o $@ $< $(IFLAGS) -DDEBUG -g

$(OBJ_DIR)-dev/%-dev.o: %.asm
	@mkdir -p $(@D)
	@echo $(CASM) $<
	@$(CASM) $(ASMFLAGS) -o $@ $< $(IFLAGS) -DDEBUG -g

$(OBJ_DIR)/%.o: %.c
	@mkdir -p $(@D)
	@echo $(CC) $<
	@$(CC) $(CFLAGS) -o $@ $< $(IFLAGS)

$(OBJ_DIR)/%.o: %.cpp
	@mkdir -p $(@D)
	@echo $(CCPP) $<
	@$(CCPP) $(CPPFLAGS) -o $@ $< $(IFLAGS)

$(OBJ_DIR)/%.o: %.asm
	@mkdir -p $(@D)
	@echo $(CASM) $<
	@$(CASM) $(ASMFLAGS) -o $@ $< $(IFLAGS)

clean:
	@rm -f $(OBJ)
	@echo rm $$\(OBJ\)
	@rm -f $(OBJ2)
	@echo rm $$\(OBJ2\)

fclean: clean
	rm -f $(NAME)
	rm -f $(NAME2)

re:

.PHONY: all clean fclean re
